---
title: Project
description: Learn about the history, roadmap, current status and more for IPFS, the InterPlanetary File System.
---

# The IPFS project

Looking to get further involved with the vibrant IPFS community and ecosystem? Curious about how it all got started, or where we're headed? Learn how to get involved, the project history, and more.

## IPFS community and ecosystem

:::callout
The IPFS community believes that our mission is best served in an environment that is friendly, safe, and accepting, and free from intimidation or harassment. To that end, we ask that everyone involved in IPFS read and respect our [code of conduct](https://github.com/ipfs/community/blob/master/code-of-conduct.md). Please contact [abuse@ipfs.tech](mailto:abuse@ipfs.tech) if you need to report a problem or address a grievance related to an abuse report.
:::

The community and ecosystem around the IPFS project is large, diverse, and abounds with opportunities for involvement. Learn more in the [Community section](../community/README.md).

## History of IPFS

Want to know how it all began? Learn the [history of the IPFS project](history.md).

## Repository guide

IPFS is a big project, which means there are a lot of GitHub repos. If you're new to IPFS or just want a sense of what to check out first, use this quick guide to the most important and most frequently used [IPFS repositories](repository-guide.md).

## IPFS specifications

[Technical specifications](https://github.com/ipfs/specs) for the IPFS protocol and its associated subsystems.

## Research

Learn more about the exploratory research work and prototyping being done for inclusion in IPFS by exploring our [research repo on GitHub](https://github.com/ipfs/notes).

## Related projects

IPFS is a highly modular project that is itself made out of many different protocols and tools. Learn more about the [IPFS-related projects](related-projects.md) under the overall support of Protocol Labs.

## Contribute to IPFS

Thousands of people contribute to IPFS from all over the world — and that can include you! No matter your areas of interest or expertise, there are a number of ways that you can make an impact on the future of the Internet by [contributing to IPFS](../community/contribute/ways-to-contribute.md).
