---
title: Kubo RPC API clients
description: List of Kubo RPC API clients.
---

# Kubo RPC API clients

When a Kubo IPFS node is running as a daemon, it exposes an HTTP RPC API that allows you to control the node and run the same commands you can from the command line. To learn more about the RPC API, see the [Kubo RPC API v0 reference](./kubo/rpc.md).

RPC API clients are available in multiple languages, and are listed below. You can request that additional clients be added to this list by [opening an issue in ipfs/ipfs-docs](https://github.com/ipfs/ipfs-docs/issues/new?assignees=&labels=need%2Ftriage&projects=&template=open_an_issue.md&title=).


| Language      | Client library                                            | Status              |
|---------------|-----------------------------------------------------------|---------------------|
| Go            | [ipfs/kubo/client/rpc](https://pkg.go.dev/github.com/ipfs/kubo/client/rpc)                | Active              |
| JavaScript    | [ipfs/js-kubo-rpc-client](https://www.npmjs.com/package/kubo-rpc-client)  | Active |
| Java          | [ipfs-shipyard/java-ipfs-http-client](https://github.com/ipfs-shipyard/java-ipfs-http-client)     | Active              |
| Python        | [ipfs-shipyard/py-ipfs-http-client](https://github.com/ipfs-shipyard/py-ipfs-http-client)       | Active |
|               | [aioipfs](https://gitlab.com/cipres/aioipfs)              | Active              |
| Scala         | [ipfs-shipyard/scala-ipfs-api](https://github.com/ipfs-shipyard/scala-ipfs-api)            | Inactive |
| Clojure       | [keorn/clj-ipfs-http-client](https://github.com/keorn/clj-ipfs-http-client)              | Inactive |
| Clojurescript | [district0x/cljs-ipfs-http-client](https://github.com/district0x/cljs-ipfs-http-client)  | Inactive |
| Haskell       | [davidar/hs-ipfs-api](https://github.com/davidar/hs-ipfs-api)                     | Inactive |
| Swift         | [ipfs-shipyard/swift-ipfs-http-client](https://github.com/ipfs-shipyard/swift-ipfs-http-client)    | Inactive |
| CommonLisp    | [WeMeetAgain/cl-ipfs-api](https://github.com/WeMeetAgain/cl-ipfs-api)                 | Inactive |
| Rust          | [ferristseng/rust-ipfs-api](https://github.com/ferristseng/rust-ipfs-api)               | Active |
|               | [gkbrk/rust-ipfs-api](https://github.com/gkbrk/rust-ipfs-api)                     | Inactive |
|               | [rmnoff/rust-ipfs-api](https://github.com/rmnoff/rust-ipfs-api)                    | Inactive |
|               | [rschulman/rust-ipfs-api](https://github.com/rschulman/rust-ipfs-api)                 | Inactive |
| Ruby          | [Fryie/ipfs-ruby](https://github.com/Fryie/ipfs-ruby)                         | Inactive |
|               | [tbenett/ruby-ipfs-http-client](https://github.com/tbenett/ruby-ipfs-http-client)           | Inactive   |
| Mac Automator | [NeoTeo/ipfs-osx-service](https://github.com/NeoTeo/ipfs-osx-service)                 | Inactive |
| Pharo         | [khinsen/ipfs-pharo](https://github.com/khinsen/ipfs-pharo)                      | Inactive   |
| PHP           |  [EdouardCourty/ipfs-php](https://github.com/EdouardCourty/ipfs-php)                | Active |
| C#            | [ipfs-shipyard/net-ipfs-http-client](https://github.com/ipfs-shipyard/net-ipfs-http-client) | Active |
|               | [jeremy-ellis-tech/net-ipfs-http-client](https://github.com/jeremy-ellis-tech/net-ipfs-http-client)  | Inactive |
|               | [richardschneider/net-ipfs-http-client](https://github.com/richardschneider/net-ipfs-http-client)   | Inactive   |
| C++           | [vasild/cpp-ipfs-api](https://github.com/vasild/cpp-ipfs-api)                    | Active   |
| Erlang        | [hendry19901990/erlang-ipfs-http-client](https://github.com/hendry19901990/erlang-ipfs-http-client) | Inactive |
| Scheme        | [siiky/ipfs.scm](https://git.sr.ht/~siiky/ipfs.scm) | Active |
| Lua           | [siiky/ipfs.lua](https://git.sr.ht/~siiky/ipfs.lua) | Active |
| Elixir        | [bahner/ex-ipfs](https://github.com/bahner/ex-ipfs) | Active |
