+++
title = "Joining a collaborative cluster"
weight = 20
aliases = []
+++

# Joining a collaborative cluster

Collaborative clusters allow people to join forces to backup and distribute interesting content on the IPFS-network.

These clusters are formed by a group of *trusted peers*, which add and modify the list of items in the cluster, and a group of *followers*, which subscribe to the cluster and pin things accordingly.

## Joining a cluster using ipfs-cluster-follow

You should be able to join using a single oneliner:

```sh
ipfs-cluster-follow <clusterName> run --init <template-configuration-url>
```

<div class="tipbox warning">Always run on the same or on a newer IPFS Cluster version than the version used by the trusted peers in the cluster.</div>

If you don't have or don't know a URL for your configuration, you can ask for it to whoever runs the trusted peers for that cluster. If you know the right pieces of information (see below), you can build your own configuration, add it to IPFS, and use the gateway URL for it `http://127.0.0.1:8080/ipfs/Qmhash...`. You can also run `ipfs-cluster-follow <clusterName> init` with a random url and then replace the generated `service.json` with your own.

<div class="tipbox tip">You can customize and overwrite any configuration options set in the [remote] template using environment variables as explained in the <a href="../../reference/configuration/#using-environment-variables-to-overwrite-configuration-values">configuration reference</a>.</div>


## Finding collaborative clusters to join

Visit [collab.ipfscluster.io](https://collab.ipfscluster.io) for a list of collaborative clusters that you can join.

## Manually configuring a follower peer

The main requirement to join a collaborative cluster is to know the right pieces of information about it:

* The list of *trusted_peers*
* The multiaddresses on which to contact at least one *trusted peer*
* The value of the cluster `secret`
* The `crdt/cluster_name` (if other than default)

Placing that information in a `service.json` configuration file, as generated by `ipfs-cluster-service init`, should be enough to create a peer that joins an existing cluster either using `ipfs-cluster-service` or `ipfs-cluster-follow`.

For more information about `ipfs-cluster-follow`, check the [reference](/documentation/reference/follow).
