+++
title = "Release 0.12.0"
date = 2019-12-20
publishdate = 2019-12-20
author = "@hsanjuan"
+++

## 20201220 | Release 0.12.0

IPFS Cluster 0.12.0 is here! It comes with the new `ipfs-cluster-follow`
application, a super-easy way of launching a "follower" peer.

Follower cluster peers join clusters to participate in the replication and
distribution of IPFS content, but do not have permissions to modify the
Cluster peerset or perform actions on other peers of the Cluster. When running
`ipfs-cluster-follow`, peers are automatically configured with a template
configuration fetched through IPFS (or any HTTP url) and run with some
follower-optimized parameters. Additionally, `ipfs-cluster-follow` can setup
and run multiple peers in parallel, so users can subscribe to several clusters
at the same time.

<div class="tipbox tip">Minor release 0.12.1 contains some minor fixes to <code>ipfs-cluster-follow</code>.</div>

Would you like to try it out? Grab [ipfs-cluster-follow](https://dist.ipfs.io/#ipfs-cluster-follow) and run:

```sh
./ipfs-cluster-follow ipfs-websites init ipfs-websites.collab.ipfscluster.io
./ipfs-cluster-follow ipfs-websites run
```

<script id="asciicast-289914" src="https://asciinema.org/a/289914.js" async></script>

Your IPFS daemon will start pinning a list of IPFS-related websites (you will
need about 600MB of available space). You can stop and re-start your followers
any time and they will catch up to the latest state of things.

We have also added a bunch of new features. Pins can now have expiration times
so that they are automatically unpinned at some point. And Cluster operators
can now use the Cluster-GC command to trigger garbage collections on all the
managed IPFS daemons. These should be very useful for IPFS storage providers.

Finally, users running clusters behind NATs or in Dockerized environments will
benefit from improvements in NAT traversal and connectivity. Cluster peers now
support the new libp2p QUIC transport and TLS handshake.

You can read more information about all the new things for this release in the
[changelog](https://github.com/ipfs-cluster/ipfs-cluster/blob/master/CHANGELOG.md).

We hope the possibilities opened by this new release will make IPFS Cluster a
very useful tool for hosting and re-distributing IPFS data in a collaborative
manner, building communities around archives based on user interests and
strenghthening content distribution in the IPFS network by doing so.
