+++
title = "NFT.storage - powered by IPFS Cluster v0.13.3"
date = 2021-05-14
publishdate = 2021-05-14
author = "@hsanjuan"
+++

## 20210514 | NFT.storage - powered by IPFS Cluster v0.13.3

Filecoin recently announced the launch of [NFT.storage](https://nft.storage),
a pinning service to provide [perpetual IPFS storage specifically catered to
NFT creators and
collectors](https://filecoin.io/blog/posts/introducing-nft.storage-free-decentralized-storage-for-nfts/).

The service is backed by storage provided by Pinata and Protocol Labs, with
the service on the Protocol Labs side relying on IPFS Cluster for pin tracking and
replication.

The service has been setup as a
[collaborative cluster](https://collab.ipfscluster.io) with 3 main storage
peers run by Protocol Labs. The Cluster currently tracks and pins 1.900.000+ items,
including many existing NFTs from around the web, which are preserved for posterity.

To better support the requirements of the project, a couple of upgrades have
been added to IPFS Cluster:

* First, we have enabled batch-pin ingest in CRDT-mode. This allowed us to
  easily ingest over 400.000 pins to the cluster in less than 1 hour, with a
  very low cost to the system. From that point, the cluster peers make sure
  that IPFS pins the items in an orderly fashion, restarting stuck pins as needed.

* Second, we have added the possibility of adding arbitrary DAGs to the
  cluster directly, by enabling CAR-file imports on the `/add` endpoint. This
  powers the storage of CBOR-encoded DAGs, that include metadata and links to
  the actual NFT-material.

These features have been included in
[IPFS Cluster 0.13.3](https://github.com/ipfs-cluster/ipfs-cluster/blob/master/CHANGELOG.md),
which we just released.

Happy pinning (and now, at very high rates)!
