+++
title = "Support"
weight = 30
+++

# Support

We are happy to support you, answer questions, and help you use IPFS Cluster. You can reach out to the team and the community in several different ways:

* For **general questions and usage guidance**: we prefer that you open a topic at https://discuss.ipfs.io/.
* For **bugs and feature requests**: please open [issues](https://github.com/ipfs-cluster/ipfs-cluster/issues) in the repository.
* For **quick chat and questions**: join the [\#ipfs-cluster](https://app.element.io/#/room/#ipfs-cluster:ipfs.io) channel on Matrix.

_Interactions in all of these venues is governed by the [IPFS Community Code of Conduct](https://github.com/ipfs/community/blob/master/code-of-conduct.md)._

If you are looking for things to start with, [filter for issues with `easy` and `ready` labels](https://github.com/ipfs-cluster/ipfs-cluster/issues?q=is%3Aopen+is%3Aissue+label%3Adifficulty%3Aeasy+label%3Aready).

In general, [anything marked with `help wanted`](https://github.com/ipfs-cluster/ipfs-cluster/issues?q=is%3Aopen+is%3Aissue+label%3Aready+label%3A%22help+wanted%22) is ready to be taken on by external contributors.

Please let us know when you are going to work on something, or more clarifications are needed, so we can help you out!


# Getting oriented

To check what's going on in the project, check:

- the [Changelog](https://github.com/ipfs-cluster/ipfs-cluster/blob/master/CHANGELOG.md)
- the [News](/news)
- the [Roadmap](/documentation/roadmap)
- the [upcoming release issues](https://github.com/ipfs-cluster/ipfs-cluster/issues?q=label%3Arelease)


# Contribution Guidelines

IPFS Cluster adopts the existing guidelines in the IPFS community:

* The [Go contribution guidelines](https://github.com/ipfs/community/blob/master/go-code-guidelines.md)
* The [IPFS community contributing notes](https://github.com/ipfs/community/blob/master/CONTRIBUTING.md)
* The [IPFS Community Code of Conduct](https://github.com/ipfs/community/blob/master/code-of-conduct.md)


## Code contribution guidelines

In practice, these are our soft standards:

* IPFS Cluster uses the Apache2/MIT dual license.
* All contributions are via Pull Request, which needs a Code Review approval from one of the project collaborators.
* Tests must pass (although sometimes it takes several runs)
* Code coverage must be stable or increase
* We prefer meaningful branch names: `feat/999-adding-this`, `fix/392-error-doing-this`... preferably with an issue number in them as well.
* We prefer commit messages which reference an issue `fix #999: ...`

These are just guidelines. We are friendly people and are happy to help :)

# Do you use IPFS Cluster?

Let us know about your setup by contributing to the [IPFS Cluster user registry](https://docs.google.com/forms/d/e/1FAIpQLSdWF5aXNXrAK_sCyu1eVv2obTaKVO3Ac5dfgl2r5_IWcizGRg/viewform).
